function Inset_Corner(A,B,C,width){
	var splitLeft = B.clone().sub(A).normalize()
	var splitRight = C.clone().sub(B).normalize()
	
	var raw_attractor = splitLeft.clone().sub(splitRight);
	raw_attractor.normalize();
	
	var test_angle = new THREE.Vector3();
	test_angle.x = -splitLeft.z;
	test_angle.z = splitLeft.x;
	
	if(raw_attractor.length()==0){
		test_angle.multiplyScalar(width);
		return B.clone().sub(test_angle)
	}

	var back_angle = Math.acos(raw_attractor.dot(splitLeft));//angle between
	raw_attractor.divideScalar(Math.sin(back_angle));
	raw_attractor.multiplyScalar(width);
	
	if(test_angle.dot(splitRight)<0){//convex
		return B.clone().sub(raw_attractor)
	}else{ //concave
		return B.clone().add(raw_attractor)
	}
}

function Inset_Path(Target,width){
	
	var splits = []
	splits.push(Target[0].clone().sub(Target[Target.length-2]).normalize())
	for(var i=1;i<Target.length;i++){
		splits.push(Target[i].clone().sub(Target[i-1]).normalize())
	}
	
	//now to create the decension angles
	var raw_attractor
	var offset

	var geometry = []
	for(var i=0;i<Target.length-1;i++){
		//going toward the center is not the bisector
		raw_attractor = splits[i].clone().sub(splits[i+1]);
		raw_attractor.normalize();
		
		var back_angle = Math.acos(raw_attractor.dot(splits[i]));//angle between
		raw_attractor.divideScalar(Math.sin(back_angle));
		raw_attractor.multiplyScalar(width);
		var test_angle = new THREE.Vector3();
		test_angle.x = -splits[i].z;
		test_angle.z = splits[i].x;
		if(test_angle.dot(splits[i+1])<0){//convex
			geometry.push(Target[i].clone().sub(raw_attractor))
		}else{ //concave
			geometry.push(Target[i].clone().add(raw_attractor))
		}
	}
	geometry.push(geometry[0].clone());
	
	return geometry

}

function displayPath(target,height){
	var geometry = new THREE.Geometry()
	var v
	var t = 0
	for(var ii=0;ii<target.length;ii++){
		v = target[ii].clone()
		v.y = height + t*2
		t++
		geometry.vertices.push(v.clone())
	}
	v.add(new THREE.Vector3(0,5,0))
	geometry.vertices.push(v)
	var line = new THREE.Line(geometry)
	reality.add(line)
}

function orientation(target){
	var vectorA = target[1].clone().sub(target[0]).normalize()
	var vectorB = target[2].clone().sub(target[0]).normalize()
	var normal = vectorA.cross(vectorB)
	return (normal.y<0)
}



function invert(target){
	var product = []
	for(var ii=target.length-1;ii>=0;ii--){
		product.push(target[ii])
	}
	return product
}

function clockwiseOrient(target){
	if(orientation(target)){
		return target
	}else{
		return invert(target)
	}
}

function vector2path(border){
	var product = [];
	for(var ii=0;ii<border.length;ii++){
		if(border[ii].x==0){border[ii].x=0}
		if(border[ii].z==0){border[ii].z=0}
		product.push({X: Math.round(border[ii].x),Y: Math.round(border[ii].z)})
	}
	return [product];
}

function findAngle(x,z){
	if(x==0){
		if(z>0){
			return Math.PI/2
		}else{
			return 3*Math.PI/2
		}
	}
	var product = Math.atan(z/x)
	if(x>0){product+=Math.PI}
	if(product<0){product+=2*Math.PI}
	return product
}

function Generate_Walls(pTarget,height,inset){
	var elevation = pTarget[0].y
	for(var ii=0;ii<pTarget.length;ii++){
		pTarget[ii].y = 0
	}
	pTarget.push(pTarget[0])
	var Target = Inset_Path(pTarget,inset)
	var product = [];
	for(var ii=0;ii<Target.length-1;ii++){
		var insets = [Target[ii],Target[ii+1]]
		var outsets = [pTarget[ii],pTarget[ii+1]]
		product.push(new PRIM_WALL(insets,outsets,elevation,elevation+height))
		
		/*var border = new Border_Widget()
		border.vertices.push(
			new Point_Widget( Target[ii].clone(),border),
			new Point_Widget( Target[ii].clone().add(new THREE.Vector3(0,height)),border),
			new Point_Widget( Target[ii+1].clone().add(new THREE.Vector3(0,height)),border),
			new Point_Widget( Target[ii+1].clone(),border)
		)
		var surface = new Surface_Pro(border)
		product.push(surface)*/
	}
	return product
}